<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSBookingPair ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSBookingPair extends AbstractStructArrayBase
{
    /**
     * The WSBookingPair
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSBookingPair[]
     */
    public $WSBookingPair;
    /**
     * Constructor method for ArrayOfWSBookingPair
     * @uses ArrayOfWSBookingPair::setWSBookingPair()
     * @param \StructType\WSBookingPair[] $wSBookingPair
     */
    public function __construct(array $wSBookingPair = array())
    {
        $this
            ->setWSBookingPair($wSBookingPair);
    }
    /**
     * Get WSBookingPair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSBookingPair[]|null
     */
    public function getWSBookingPair()
    {
        return isset($this->WSBookingPair) ? $this->WSBookingPair : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSBookingPair method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSBookingPair method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSBookingPairForArrayConstraintsFromSetWSBookingPair(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSBookingPairWSBookingPairItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSBookingPairWSBookingPairItem instanceof \StructType\WSBookingPair) {
                $invalidValues[] = is_object($arrayOfWSBookingPairWSBookingPairItem) ? get_class($arrayOfWSBookingPairWSBookingPairItem) : sprintf('%s(%s)', gettype($arrayOfWSBookingPairWSBookingPairItem), var_export($arrayOfWSBookingPairWSBookingPairItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSBookingPair property can only contain items of type \StructType\WSBookingPair, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSBookingPair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSBookingPair[] $wSBookingPair
     * @return \ArrayType\ArrayOfWSBookingPair
     */
    public function setWSBookingPair(array $wSBookingPair = array())
    {
        // validation for constraint: array
        if ('' !== ($wSBookingPairArrayErrorMessage = self::validateWSBookingPairForArrayConstraintsFromSetWSBookingPair($wSBookingPair))) {
            throw new \InvalidArgumentException($wSBookingPairArrayErrorMessage, __LINE__);
        }
        if (is_null($wSBookingPair) || (is_array($wSBookingPair) && empty($wSBookingPair))) {
            unset($this->WSBookingPair);
        } else {
            $this->WSBookingPair = $wSBookingPair;
        }
        return $this;
    }
    /**
     * Add item to WSBookingPair value
     * @throws \InvalidArgumentException
     * @param \StructType\WSBookingPair $item
     * @return \ArrayType\ArrayOfWSBookingPair
     */
    public function addToWSBookingPair(\StructType\WSBookingPair $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSBookingPair) {
            throw new \InvalidArgumentException(sprintf('The WSBookingPair property can only contain items of type \StructType\WSBookingPair, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSBookingPair[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSBookingPair|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSBookingPair|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSBookingPair|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSBookingPair|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSBookingPair|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSBookingPair
     */
    public function getAttributeName()
    {
        return 'WSBookingPair';
    }
}
