<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSExtensibleCustomer ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSExtensibleCustomer extends AbstractStructArrayBase
{
    /**
     * The WSExtensibleCustomer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSExtensibleCustomer[]
     */
    public $WSExtensibleCustomer;
    /**
     * Constructor method for ArrayOfWSExtensibleCustomer
     * @uses ArrayOfWSExtensibleCustomer::setWSExtensibleCustomer()
     * @param \StructType\WSExtensibleCustomer[] $wSExtensibleCustomer
     */
    public function __construct(array $wSExtensibleCustomer = array())
    {
        $this
            ->setWSExtensibleCustomer($wSExtensibleCustomer);
    }
    /**
     * Get WSExtensibleCustomer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSExtensibleCustomer[]|null
     */
    public function getWSExtensibleCustomer()
    {
        return isset($this->WSExtensibleCustomer) ? $this->WSExtensibleCustomer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSExtensibleCustomer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSExtensibleCustomer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSExtensibleCustomerForArrayConstraintsFromSetWSExtensibleCustomer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSExtensibleCustomerWSExtensibleCustomerItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSExtensibleCustomerWSExtensibleCustomerItem instanceof \StructType\WSExtensibleCustomer) {
                $invalidValues[] = is_object($arrayOfWSExtensibleCustomerWSExtensibleCustomerItem) ? get_class($arrayOfWSExtensibleCustomerWSExtensibleCustomerItem) : sprintf('%s(%s)', gettype($arrayOfWSExtensibleCustomerWSExtensibleCustomerItem), var_export($arrayOfWSExtensibleCustomerWSExtensibleCustomerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSExtensibleCustomer property can only contain items of type \StructType\WSExtensibleCustomer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSExtensibleCustomer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSExtensibleCustomer[] $wSExtensibleCustomer
     * @return \ArrayType\ArrayOfWSExtensibleCustomer
     */
    public function setWSExtensibleCustomer(array $wSExtensibleCustomer = array())
    {
        // validation for constraint: array
        if ('' !== ($wSExtensibleCustomerArrayErrorMessage = self::validateWSExtensibleCustomerForArrayConstraintsFromSetWSExtensibleCustomer($wSExtensibleCustomer))) {
            throw new \InvalidArgumentException($wSExtensibleCustomerArrayErrorMessage, __LINE__);
        }
        if (is_null($wSExtensibleCustomer) || (is_array($wSExtensibleCustomer) && empty($wSExtensibleCustomer))) {
            unset($this->WSExtensibleCustomer);
        } else {
            $this->WSExtensibleCustomer = $wSExtensibleCustomer;
        }
        return $this;
    }
    /**
     * Add item to WSExtensibleCustomer value
     * @throws \InvalidArgumentException
     * @param \StructType\WSExtensibleCustomer $item
     * @return \ArrayType\ArrayOfWSExtensibleCustomer
     */
    public function addToWSExtensibleCustomer(\StructType\WSExtensibleCustomer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSExtensibleCustomer) {
            throw new \InvalidArgumentException(sprintf('The WSExtensibleCustomer property can only contain items of type \StructType\WSExtensibleCustomer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSExtensibleCustomer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSExtensibleCustomer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSExtensibleCustomer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSExtensibleCustomer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSExtensibleCustomer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSExtensibleCustomer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSExtensibleCustomer
     */
    public function getAttributeName()
    {
        return 'WSExtensibleCustomer';
    }
}
