<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSModificationError ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSModificationError extends AbstractStructArrayBase
{
    /**
     * The WSModificationError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSModificationError[]
     */
    public $WSModificationError;
    /**
     * Constructor method for ArrayOfWSModificationError
     * @uses ArrayOfWSModificationError::setWSModificationError()
     * @param \StructType\WSModificationError[] $wSModificationError
     */
    public function __construct(array $wSModificationError = array())
    {
        $this
            ->setWSModificationError($wSModificationError);
    }
    /**
     * Get WSModificationError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSModificationError[]|null
     */
    public function getWSModificationError()
    {
        return isset($this->WSModificationError) ? $this->WSModificationError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSModificationError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSModificationError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSModificationErrorForArrayConstraintsFromSetWSModificationError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSModificationErrorWSModificationErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSModificationErrorWSModificationErrorItem instanceof \StructType\WSModificationError) {
                $invalidValues[] = is_object($arrayOfWSModificationErrorWSModificationErrorItem) ? get_class($arrayOfWSModificationErrorWSModificationErrorItem) : sprintf('%s(%s)', gettype($arrayOfWSModificationErrorWSModificationErrorItem), var_export($arrayOfWSModificationErrorWSModificationErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSModificationError property can only contain items of type \StructType\WSModificationError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSModificationError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSModificationError[] $wSModificationError
     * @return \ArrayType\ArrayOfWSModificationError
     */
    public function setWSModificationError(array $wSModificationError = array())
    {
        // validation for constraint: array
        if ('' !== ($wSModificationErrorArrayErrorMessage = self::validateWSModificationErrorForArrayConstraintsFromSetWSModificationError($wSModificationError))) {
            throw new \InvalidArgumentException($wSModificationErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($wSModificationError) || (is_array($wSModificationError) && empty($wSModificationError))) {
            unset($this->WSModificationError);
        } else {
            $this->WSModificationError = $wSModificationError;
        }
        return $this;
    }
    /**
     * Add item to WSModificationError value
     * @throws \InvalidArgumentException
     * @param \StructType\WSModificationError $item
     * @return \ArrayType\ArrayOfWSModificationError
     */
    public function addToWSModificationError(\StructType\WSModificationError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSModificationError) {
            throw new \InvalidArgumentException(sprintf('The WSModificationError property can only contain items of type \StructType\WSModificationError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSModificationError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSModificationError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSModificationError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSModificationError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSModificationError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSModificationError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSModificationError
     */
    public function getAttributeName()
    {
        return 'WSModificationError';
    }
}
