<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSTripModification ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSTripModification extends AbstractStructArrayBase
{
    /**
     * The WSTripModification
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTripModification[]
     */
    public $WSTripModification;
    /**
     * Constructor method for ArrayOfWSTripModification
     * @uses ArrayOfWSTripModification::setWSTripModification()
     * @param \StructType\WSTripModification[] $wSTripModification
     */
    public function __construct(array $wSTripModification = array())
    {
        $this
            ->setWSTripModification($wSTripModification);
    }
    /**
     * Get WSTripModification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTripModification[]|null
     */
    public function getWSTripModification()
    {
        return isset($this->WSTripModification) ? $this->WSTripModification : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSTripModification method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSTripModification method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSTripModificationForArrayConstraintsFromSetWSTripModification(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSTripModificationWSTripModificationItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSTripModificationWSTripModificationItem instanceof \StructType\WSTripModification) {
                $invalidValues[] = is_object($arrayOfWSTripModificationWSTripModificationItem) ? get_class($arrayOfWSTripModificationWSTripModificationItem) : sprintf('%s(%s)', gettype($arrayOfWSTripModificationWSTripModificationItem), var_export($arrayOfWSTripModificationWSTripModificationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSTripModification property can only contain items of type \StructType\WSTripModification, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSTripModification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSTripModification[] $wSTripModification
     * @return \ArrayType\ArrayOfWSTripModification
     */
    public function setWSTripModification(array $wSTripModification = array())
    {
        // validation for constraint: array
        if ('' !== ($wSTripModificationArrayErrorMessage = self::validateWSTripModificationForArrayConstraintsFromSetWSTripModification($wSTripModification))) {
            throw new \InvalidArgumentException($wSTripModificationArrayErrorMessage, __LINE__);
        }
        if (is_null($wSTripModification) || (is_array($wSTripModification) && empty($wSTripModification))) {
            unset($this->WSTripModification);
        } else {
            $this->WSTripModification = $wSTripModification;
        }
        return $this;
    }
    /**
     * Add item to WSTripModification value
     * @throws \InvalidArgumentException
     * @param \StructType\WSTripModification $item
     * @return \ArrayType\ArrayOfWSTripModification
     */
    public function addToWSTripModification(\StructType\WSTripModification $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSTripModification) {
            throw new \InvalidArgumentException(sprintf('The WSTripModification property can only contain items of type \StructType\WSTripModification, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSTripModification[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSTripModification|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSTripModification|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSTripModification|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSTripModification|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSTripModification|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSTripModification
     */
    public function getAttributeName()
    {
        return 'WSTripModification';
    }
}
