<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getGenericProperties StructType
 * Meta information extracted from the WSDL
 * - type: tns:getGenericProperties
 * @subpackage Structs
 */
class GetGenericProperties extends AbstractStructBase
{
    /**
     * The arg0
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $arg0;
    /**
     * The arg1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\WSLink
     */
    public $arg1;
    /**
     * The arg2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString_1
     */
    public $arg2;
    /**
     * The arg3
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfWSKeyValue
     */
    public $arg3;
    /**
     * Constructor method for getGenericProperties
     * @uses GetGenericProperties::setArg0()
     * @uses GetGenericProperties::setArg1()
     * @uses GetGenericProperties::setArg2()
     * @uses GetGenericProperties::setArg3()
     * @param string $arg0
     * @param \StructType\WSLink $arg1
     * @param \ArrayType\ArrayOfString_1 $arg2
     * @param \ArrayType\ArrayOfWSKeyValue $arg3
     */
    public function __construct($arg0 = null, \StructType\WSLink $arg1 = null, \ArrayType\ArrayOfString_1 $arg2 = null, \ArrayType\ArrayOfWSKeyValue $arg3 = null)
    {
        $this
            ->setArg0($arg0)
            ->setArg1($arg1)
            ->setArg2($arg2)
            ->setArg3($arg3);
    }
    /**
     * Get arg0 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getArg0()
    {
        return isset($this->arg0) ? $this->arg0 : null;
    }
    /**
     * Set arg0 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $arg0
     * @return \StructType\GetGenericProperties
     */
    public function setArg0($arg0 = null)
    {
        // validation for constraint: string
        if (!is_null($arg0) && !is_string($arg0)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($arg0, true), gettype($arg0)), __LINE__);
        }
        if (is_null($arg0) || (is_array($arg0) && empty($arg0))) {
            unset($this->arg0);
        } else {
            $this->arg0 = $arg0;
        }
        return $this;
    }
    /**
     * Get arg1 value
     * @return \StructType\WSLink|null
     */
    public function getArg1()
    {
        return $this->arg1;
    }
    /**
     * Set arg1 value
     * @param \StructType\WSLink $arg1
     * @return \StructType\GetGenericProperties
     */
    public function setArg1(\StructType\WSLink $arg1 = null)
    {
        $this->arg1 = $arg1;
        return $this;
    }
    /**
     * Get arg2 value
     * @return \ArrayType\ArrayOfString_1|null
     */
    public function getArg2()
    {
        return $this->arg2;
    }
    /**
     * Set arg2 value
     * @param \ArrayType\ArrayOfString_1 $arg2
     * @return \StructType\GetGenericProperties
     */
    public function setArg2(\ArrayType\ArrayOfString_1 $arg2 = null)
    {
        $this->arg2 = $arg2;
        return $this;
    }
    /**
     * Get arg3 value
     * @return \ArrayType\ArrayOfWSKeyValue|null
     */
    public function getArg3()
    {
        return $this->arg3;
    }
    /**
     * Set arg3 value
     * @param \ArrayType\ArrayOfWSKeyValue $arg3
     * @return \StructType\GetGenericProperties
     */
    public function setArg3(\ArrayType\ArrayOfWSKeyValue $arg3 = null)
    {
        $this->arg3 = $arg3;
        return $this;
    }
}
